/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sun.jsat;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Enumeration;
import java.util.List;
import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.SwingUtilities;
import javax.swing.tree.TreePath;
import org.sun.jsat.trees.CodeGroupingRootTreeNode;
import org.sun.jsat.trees.FilledActionDefTreeNode;
import org.sun.jsat.trees.FilledRuleDefTreeNode;
import org.sun.jsat.trees.RefreshableTreeNode;
import org.sun.jsat.trees.RootTreeNodeMaker;
import org.sun.jsat.trees.ToolTipTree;
import securityanalyzer.useframework.RulesActionsContainer;

/**
 *
 * @author joe
 */
public class PolicyDiffWindow extends JFrame {

    JSATMain main;
    RootTreeNodeMaker rootNodes;
    ToolTipTree actionTree1;
    ToolTipTree actionTree2;
    ToolTipTree ruleTree1;
    ToolTipTree ruleTree2;
    JComboBox policy1Chooser;
    JComboBox policy2Chooser;
    JPanel toolBarPanel;
    JPanel mainPanel;
    JPanel actionsPanel;
    JPanel rulesPanel;
    JPanel action1Panel;
    JPanel action2Panel;
    JPanel rule1Panel;
    JPanel rule2Panel;
    JPanel centerPanel1;
    JPanel centerPanel2;
    JLabel action1Label;
    JLabel action2Label;
    JLabel rule1Label;
    JLabel rule2Label;
    JScrollPane action1ScrollPane;
    JScrollPane action2ScrollPane;
    JScrollPane rule1ScrollPane;
    JScrollPane rule2ScrollPane;
    JButton addAction1to2;
    JButton addAction2to1;
    JButton addRule1to2;
    JButton addRule2to1;
    RefreshableTreeNode actionTree1Root = new RefreshableTreeNode(null, "");
    RefreshableTreeNode actionTree2Root = new RefreshableTreeNode(null, "");
    RefreshableTreeNode ruleTree1Root = new RefreshableTreeNode(null, "");
    RefreshableTreeNode ruleTree2Root = new RefreshableTreeNode(null, "");
    CodeGroupingRootTreeNode ruleTreeNode1 = new CodeGroupingRootTreeNode(null, CodeGroupingRootTreeNode.DISPLAY_RULES);
    CodeGroupingRootTreeNode ruleTreeNode2 = new CodeGroupingRootTreeNode(null, CodeGroupingRootTreeNode.DISPLAY_RULES);
    CodeGroupingRootTreeNode actionTreeNode1 = new CodeGroupingRootTreeNode(null, CodeGroupingRootTreeNode.DISPLAY_ACTIONS);
    CodeGroupingRootTreeNode actionTreeNode2 = new CodeGroupingRootTreeNode(null, CodeGroupingRootTreeNode.DISPLAY_ACTIONS);

    
    
    public PolicyDiffWindow(JSATMain main) {
        this.main = main;
        this.rootNodes = new RootTreeNodeMaker(main.getSecurityModel());
        initComponents();
        initContents();
        initListeners();
    }
    
    private void initComponents() {
        toolBarPanel = new JPanel();
        mainPanel = new JPanel();

        actionTree1 = new ToolTipTree(actionTree1Root);
        actionTree2 = new ToolTipTree(actionTree2Root);
        ruleTree1 = new ToolTipTree(ruleTree1Root);
        ruleTree2 = new ToolTipTree(ruleTree2Root);

        actionTree1.setRootVisible(false);
        actionTree2.setRootVisible(false);
        ruleTree1.setRootVisible(false);
        ruleTree2.setRootVisible(false);

        actionTree1.setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));
        actionTree2.setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));
        ruleTree1.setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));
        ruleTree2.setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));

        action1ScrollPane = new JScrollPane();
        action2ScrollPane = new JScrollPane();
        rule1ScrollPane = new JScrollPane();
        rule2ScrollPane = new JScrollPane();

        policy1Chooser = new JComboBox();
        policy2Chooser = new JComboBox();

        action1Panel = new JPanel();
        action2Panel = new JPanel();
        rule1Panel = new JPanel();
        rule2Panel = new JPanel();

        action1Label = new JLabel("Action 1:");
        action2Label = new JLabel("Action 2:");
        rule1Label = new JLabel("Rule 1:");
        rule2Label = new JLabel("Rule 2:");

        action1Panel.setLayout(new BoxLayout(action1Panel, BoxLayout.Y_AXIS));
        action2Panel.setLayout(new BoxLayout(action2Panel, BoxLayout.Y_AXIS));
        rule1Panel.setLayout(new BoxLayout(rule1Panel, BoxLayout.Y_AXIS));
        rule2Panel.setLayout(new BoxLayout(rule2Panel, BoxLayout.Y_AXIS));

        action1ScrollPane.setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));
        action2ScrollPane.setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));
        rule1ScrollPane.setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));
        rule2ScrollPane.setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));

        addAction1to2 = new JButton("Add-->");
        addAction1to2.setEnabled(false);
        addAction2to1 = new JButton("<--Add");
        addAction2to1.setEnabled(false);

        addRule1to2 = new JButton("Add-->");
        addRule1to2.setEnabled(false);
        addRule2to1 = new JButton("<--Add");
        addRule2to1.setEnabled(false);

        actionsPanel = new JPanel();
        rulesPanel = new JPanel();
        centerPanel1 = new JPanel();
        centerPanel2 = new JPanel();
        centerPanel1.setPreferredSize(new Dimension(100, 200));
        centerPanel2.setPreferredSize(new Dimension(100, 200));

        action1ScrollPane.add(actionTree1);
        action1ScrollPane.setViewportView(actionTree1);
        action2ScrollPane.add(actionTree2);
        action2ScrollPane.setViewportView(actionTree2);
        rule1ScrollPane.add(ruleTree1);
        rule1ScrollPane.setViewportView(ruleTree1);
        rule2ScrollPane.add(ruleTree2);
        rule2ScrollPane.setViewportView(ruleTree2);

        action1Panel.add(action1Label);
        action1Panel.add(action1ScrollPane);
        action2Panel.add(action2Label);
        action2Panel.add(action2ScrollPane);
        rule1Panel.add(rule1Label);
        rule1Panel.add(rule1ScrollPane);
        rule2Panel.add(rule2Label);
        rule2Panel.add(rule2ScrollPane);

        centerPanel1.setLayout(new BoxLayout(centerPanel1, BoxLayout.Y_AXIS));
        centerPanel2.setLayout(new BoxLayout(centerPanel2, BoxLayout.Y_AXIS));

        addAction1to2.setAlignmentX(CENTER_ALIGNMENT);
        addAction2to1.setAlignmentX(CENTER_ALIGNMENT);
        addRule1to2.setAlignmentX(CENTER_ALIGNMENT);
        addRule2to1.setAlignmentX(CENTER_ALIGNMENT);

        centerPanel1.add(addAction1to2);
        centerPanel1.add(addAction2to1);

        centerPanel2.add(addRule1to2);
        centerPanel2.add(addRule2to1);

        actionsPanel.setLayout(new GridLayout(1, 3));
        rulesPanel.setLayout(new GridLayout(1, 3));

        actionsPanel.add(action1Panel);
        actionsPanel.add(centerPanel1);
        actionsPanel.add(action2Panel);

        rulesPanel.add(rule1Panel);
        rulesPanel.add(centerPanel2);
        rulesPanel.add(rule2Panel);

        mainPanel.setLayout(new GridLayout(2, 1));

        mainPanel.add(actionsPanel);
        mainPanel.add(rulesPanel);

        toolBarPanel.setLayout(new BorderLayout());

        toolBarPanel.add(policy1Chooser, BorderLayout.WEST);
        toolBarPanel.add(policy2Chooser, BorderLayout.EAST);

        this.setLayout(new BoxLayout(this.getContentPane(), BoxLayout.Y_AXIS));
        this.add(toolBarPanel);
        this.add(mainPanel);

        this.setSize(this.getPreferredSize());
    }

    private void initListeners() {

        policy1Chooser.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                policy1ChooserActionPerformed();
            }
        });

        policy2Chooser.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                policy2ChooserActionPerformed();
            }
        });

        addAction1to2.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                addAction1to2ActionPerformed();
            }
        });

        addAction2to1.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                addAction2to1ActionPerformed();
            }
        });

        addRule1to2.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                addRule1to2ActionPerformed();
            }
        });

        addRule2to1.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                addRule2to1ActionPerformed();
            }
        });
        
        actionTree1.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                actionTree1MousePressed(e);
            }
        });
        
        actionTree2.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                actionTree2MousePressed(e);
            }
        });
        
        ruleTree1.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                ruleTree1MousePressed(e);
            }
        });
        
        ruleTree2.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                ruleTree2MousePressed(e);
            }
        });
        
        this.addWindowListener(new WindowAdapter() {
            
            @Override
            public void windowClosed(WindowEvent e) {
                finish();
            }
        });

    }

    public void actionTree1MousePressed(MouseEvent e) {
        
        TreePath tp = actionTree1.getClosestPathForLocation(e.getX(), e.getY());
        
        if(tp == null) {
            addAction1to2.setEnabled(false);
            return;
        }
        
        Object lastNode = tp.getLastPathComponent();
        
        if(lastNode instanceof FilledActionDefTreeNode) {
            addAction1to2.setEnabled(true);
        }
        else {
            addAction1to2.setEnabled(false);
        }
        
    }
    
    public void actionTree2MousePressed(MouseEvent e) {
        
        TreePath tp = actionTree2.getClosestPathForLocation(e.getX(), e.getY());
        
        if(tp == null) {
            addAction2to1.setEnabled(false);
            return;
        }
        
        Object lastNode = tp.getLastPathComponent();
        
        if(lastNode instanceof FilledActionDefTreeNode) {
            addAction2to1.setEnabled(true);
        }
        else {
            addAction2to1.setEnabled(false);
        }
        
    }
    
    public void ruleTree1MousePressed(MouseEvent e) {
        
        TreePath tp = ruleTree1.getClosestPathForLocation(e.getX(), e.getY());
        
        if(tp == null) {
            addRule1to2.setEnabled(false);
            return;
        }
        
        Object lastNode = tp.getLastPathComponent();
        
        if(lastNode instanceof FilledRuleDefTreeNode) {
            addRule1to2.setEnabled(true);
        }
        else {
            addRule1to2.setEnabled(false);
        }
        
    }
    
    public void ruleTree2MousePressed(MouseEvent e) {
        
        TreePath tp = ruleTree2.getClosestPathForLocation(e.getX(), e.getY());
        
        if(tp == null) {
            addRule2to1.setEnabled(false);
            return;
        }
        
        Object lastNode = tp.getLastPathComponent();
        
        if(lastNode instanceof FilledRuleDefTreeNode) {
            addRule2to1.setEnabled(true);
        }
        else {
            addRule2to1.setEnabled(false);
        }
        
    }


    public void initContents() {

        String[] policies = getPoliciesArray();

        policy1Chooser.setModel(new DefaultComboBoxModel(policies));
        policy1Chooser.getModel().setSelectedItem(main.getDefaultPolicyName());
        policy2Chooser.setModel(new DefaultComboBoxModel(policies));

        RulesActionsContainer rac = new RulesActionsContainer();

        main.getSecurityModel().getDefaultCodeGroup().addExternalPolicy("Empty diff", rac);

        actionTreeNode1 = rootNodes.getOrCreateActionNode(main.getDefaultPolicyName(), CodeGroupingRootTreeNode.POLICY_TYPE_EXTERNAL);
        actionTreeNode2 = rootNodes.getOrCreateActionNode("Empty diff", CodeGroupingRootTreeNode.POLICY_TYPE_EXTERNAL);
        ruleTreeNode1 = rootNodes.getOrCreateRuleNode(main.getDefaultPolicyName(), CodeGroupingRootTreeNode.POLICY_TYPE_EXTERNAL);
        ruleTreeNode2 = rootNodes.getOrCreateRuleNode("Empty diff", CodeGroupingRootTreeNode.POLICY_TYPE_EXTERNAL);

        actionTree1Root.add(actionTreeNode1);
        actionTree2Root.add(actionTreeNode2);
        ruleTree1Root.add(ruleTreeNode1);
        ruleTree2Root.add(ruleTreeNode2);

        refreshTrees();


    }

    private String[] getPoliciesArray() {

        Collection<String> externals = main.getSecurityModel().getDefaultCodeGroup().getAllExternalPolicyNames();
        Collection<String> analyses = main.getSecurityModel().getDefaultCodeGroup().getAllAnalysisPolicyNames();

        List<String> policies = new ArrayList<String>();

        for (String s : externals) {
            policies.add(s);
        }

        for (String s : analyses) {
            policies.add(s);
        }

        return policies.toArray(new String[0]);


    }

    @Override
    public Dimension getPreferredSize() {
        return new Dimension(600, 600);
    }

    public void refreshTrees() {
        //updateHighlights();
        refreshTree(actionTree1, actionTreeNode1);
        refreshTree(actionTree2, actionTreeNode2);
        refreshTree(ruleTree1, ruleTreeNode1);
        refreshTree(ruleTree2, ruleTreeNode2);
    }

    private void refreshTree(JTree tree, CodeGroupingRootTreeNode rootNode) {
        if (tree != null && rootNode != null) {
            if (rootNode.getCg() == null && main.getSecurityModel().getDefaultCodeGroup() != null) {
                rootNode.setCg(main.getSecurityModel().getDefaultCodeGroup());
            }
            rootNode.refresh();
            SwingUtilities.updateComponentTreeUI(tree);
        }
    }

    
    private void policy1ChooserActionPerformed() {
        String policyName = (String) policy1Chooser.getModel().getSelectedItem();
        
        CodeGroupingRootTreeNode newRootAction = rootNodes.getOrCreateActionNode(policyName, CodeGroupingRootTreeNode.POLICY_TYPE_EXTERNAL);
        CodeGroupingRootTreeNode newRootRule = rootNodes.getOrCreateRuleNode(policyName, CodeGroupingRootTreeNode.POLICY_TYPE_EXTERNAL);
        
        actionTreeNode1.removeFromParent();
        actionTreeNode1 = newRootAction;
        actionTree1Root.add(actionTreeNode1);
        
        ruleTreeNode1.removeFromParent();
        ruleTreeNode1 = newRootRule;
        ruleTree1Root.add(ruleTreeNode1);
        
        refreshTrees();
        
        
        
    }

    private void policy2ChooserActionPerformed() {
        String policyName = (String) policy2Chooser.getModel().getSelectedItem();
        
        CodeGroupingRootTreeNode newRootAction = rootNodes.getOrCreateActionNode(policyName, CodeGroupingRootTreeNode.POLICY_TYPE_EXTERNAL);
        CodeGroupingRootTreeNode newRootRule = rootNodes.getOrCreateRuleNode(policyName, CodeGroupingRootTreeNode.POLICY_TYPE_EXTERNAL);
        
        actionTreeNode2.removeFromParent();
        actionTreeNode2 = newRootAction;
        actionTree2Root.add(actionTreeNode2);
        
        ruleTreeNode2.removeFromParent();
        ruleTreeNode2 = newRootRule;
        ruleTree2Root.add(ruleTreeNode2);
        
        refreshTrees();
      
    }

    private void addAction1to2ActionPerformed() {
        
        Object lastNode = actionTree1.getAnchorSelectionPath().getLastPathComponent();
        
        if(!(lastNode instanceof FilledActionDefTreeNode)) {
            return;
        }
        
        FilledActionDefTreeNode actionNode = (FilledActionDefTreeNode)lastNode;
        
        String otherPolicyName = (String)policy2Chooser.getSelectedItem();
        
        RulesActionsContainer rac = getContainerByName(otherPolicyName);
        
        rac.addAction(actionNode.getBaseObject());
        
        //refreshTree(actionTree2, actionTreeNode2);
        //refreshTree(ruleTree2, ruleTreeNode2);
        
        refreshTrees();
        
    }
    
    private RulesActionsContainer getContainerByName(String name) {
        
        if(name.equals(ImportDialog.CURRENT_CONFIGURATION)) {
            return main.getSecurityModel().getDefaultCodeGroup().getCurrentPolicy();
        }
        
        RulesActionsContainer ret = main.getSecurityModel().getDefaultCodeGroup().getAnalysisPolicyByName(name);
        
        if(ret == null) {
            ret = main.getSecurityModel().getDefaultCodeGroup().getExternalPolicyByName(name);
        }
        
        return ret;
        
    }
    


    private void addAction2to1ActionPerformed() {
        
        Object lastNode = actionTree2.getAnchorSelectionPath().getLastPathComponent();
        
        if(!(lastNode instanceof FilledActionDefTreeNode)) {
            return;
        }
        
        FilledActionDefTreeNode actionNode = (FilledActionDefTreeNode)lastNode;
        
        String otherPolicyName = (String)policy1Chooser.getSelectedItem();
        
        RulesActionsContainer rac = getContainerByName(otherPolicyName);
        
        rac.addAction(actionNode.getBaseObject());
        
       // refreshTree(actionTree1, actionTreeNode1);
       // refreshTree(ruleTree1, ruleTreeNode1);
        
        refreshTrees();
    }

    private void addRule1to2ActionPerformed() {
        
                Object lastNode = ruleTree1.getAnchorSelectionPath().getLastPathComponent();
        
        if(!(lastNode instanceof FilledRuleDefTreeNode)) {
            return;
        }
        
        FilledRuleDefTreeNode ruleNode = (FilledRuleDefTreeNode)lastNode;
        
        String otherPolicyName = (String)policy2Chooser.getSelectedItem();
        
        RulesActionsContainer rac = getContainerByName(otherPolicyName);
        
        rac.addRule(ruleNode.getBaseObject());
        
        // refreshTree(ruleTree2, ruleTreeNode2);
        // refreshTree(actionTree2, actionTreeNode2);
        
        refreshTrees();
    }

    private void addRule2to1ActionPerformed() {
        
        Object lastNode = ruleTree2.getAnchorSelectionPath().getLastPathComponent();
        
        if(!(lastNode instanceof FilledRuleDefTreeNode)) {
            return;
        }
        
        FilledRuleDefTreeNode ruleNode = (FilledRuleDefTreeNode)lastNode;
        
        String otherPolicyName = (String)policy1Chooser.getSelectedItem();
        
        RulesActionsContainer rac = getContainerByName(otherPolicyName);
        
        rac.addRule(ruleNode.getBaseObject());
        
        //refreshTree(ruleTree1, ruleTreeNode1);
        //refreshTree(actionTree1, actionTreeNode1);
        
        refreshTrees();
    }
    
    /**
     * Always compares right to left
     */
    private void updateHighlights() {
        
        Enumeration actions2 = actionTreeNode2.children();
        
        searchEnumeration(actions2);
        
        Enumeration rules2 = ruleTreeNode2.children();
        
        searchEnumeration(rules2);
        
    }
    
    private void searchEnumeration(Enumeration en) {
        while(en.hasMoreElements()) {
            Object o = en.nextElement();
            processNode(o);
        }
    }
    
    private void processNode(Object o) {
        if (o instanceof FilledActionDefTreeNode) {
            processFilledActionDefNode((FilledActionDefTreeNode) o);
        } 
        else if (o instanceof FilledRuleDefTreeNode) {
            processFilledRuleDefNode((FilledRuleDefTreeNode) o);
        }
        else if (o instanceof RefreshableTreeNode) {
            RefreshableTreeNode rtn = (RefreshableTreeNode) o;
            if (rtn.getChildCount() > 0) {
                searchEnumeration(rtn.children());
            }
        }
    }
    
    private void processFilledRuleDefNode(FilledRuleDefTreeNode ruleNode) {
        ruleNode.setHighlight(false);
        matchInEnumeration(ruleNode, ruleTreeNode1.children());
    }
    
    private void processFilledActionDefNode(FilledActionDefTreeNode actionNode) {
        actionNode.setHighlight(false);
        matchInEnumeration(actionNode, actionTreeNode1.children());
    }
    
    private void matchInEnumeration(RefreshableTreeNode testNode, Enumeration en) {
        while(en.hasMoreElements()) {
            Object o = en.nextElement();
            if (testNode.equals(o)) {
                testNode.setHighlight(true);
            } else if (o instanceof RefreshableTreeNode) {
                RefreshableTreeNode node = (RefreshableTreeNode) o;
                if (node.getChildCount() > 0) {
                    matchInEnumeration(testNode, node.children());
                }
            }
        }
    }
    
    private void finish() {
        main.refreshWindow();
    }
}
