/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sun.jsat.controllers;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import javax.swing.JTree;
import org.sun.jsat.AddDialog;
import org.sun.jsat.JSATMain;
import org.sun.jsat.ParametersPanel;
import org.sun.jsat.trees.ActionDefTreeNode;
import org.sun.jsat.trees.RuleDefTreeNode;
import securityanalyzer.resourcemodel.ActionDefinition;
import securityanalyzer.resourcemodel.FilledActionDefinition;
import securityanalyzer.resourcemodel.FilledRuleDefinition;
import securityanalyzer.resourcemodel.RuleDefinition;

/**
 *
 * @author joe
 */
public class InitializeAddController implements ActionListener {

    JSATMain main;
    int type;

    public InitializeAddController(JSATMain main, int type) {
        this.main = main;
        this.type = type;
    }

    public void actionPerformed(ActionEvent e) {

        AddDialog aad = new AddDialog(type);
        AddController aac = new AddController(aad, main);

        aad.getCreateButton().addActionListener(aac);

        aad.setVisible(true);
    }
}

class AddController implements ActionListener {

    AddDialog aad;
    JSATMain main;

    public AddController(AddDialog aad, JSATMain main) {
        this.aad = aad;
        this.main = main;
    }

    public void actionPerformed(ActionEvent e) {

        JTree jt = aad.getDefinitionsTree();

        Object lastNode = jt.getAnchorSelectionPath().getLastPathComponent();

        ParametersPanel pp = aad.getParametersPanel();

        List<String> parameterNames = pp.getParameterNames();
        List<String> parameterValues = pp.getParameterValues();

        aad.dispose();

        switch (aad.getType()) {
            case AddDialog.ADDING_ACTIONS:
                if (lastNode instanceof ActionDefTreeNode) {

                    ActionDefinition ad = ((ActionDefTreeNode) lastNode).getBaseObject();

                    FilledActionDefinition fad = new FilledActionDefinition(ad);

                    int i = 0;
                    for (String name : parameterNames) {
                        String value = parameterValues.get(i);
                        i++;
                        fad.setMapping(ad.getParameter(name), value);
                    }
                    
                    main.addAction(fad);
                }
                break;
            case AddDialog.ADDING_RULES:
                if (lastNode instanceof RuleDefTreeNode) {

                    RuleDefinition rd = ((RuleDefTreeNode) lastNode).getBaseObject();

                    FilledRuleDefinition frd = new FilledRuleDefinition(rd);

                    int i = 0;
                    for (String name : parameterNames) {
                        String value = parameterValues.get(i);
                        i++;
                        frd.setMapping(rd.getParameterByName(name), value);
                    }
                    
                    main.addRule(frd);
                }
                break;
            default:
                return;
        }

    }
}


