/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sun.jsat.controllers;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import org.sun.jsat.CodeGroupInitializer;
import org.sun.jsat.JSATMain;
import securityanalyzer.useframework.PolicyConfigurationReader;
import securityanalyzer.useframework.RulesActionsContainer;
import securityanalyzer.useframework.SecurityModel;

/**
 *
 * @author joe
 */
public class StartupController implements ActionListener {

    CodeGroupInitializer cgi;
    JSATMain main;

    public StartupController(JSATMain main) {
        this.main = main;
    }

    public void doStartup() {

        cgi = new CodeGroupInitializer();
        cgi.getStartButton().addActionListener(this);
        cgi.setVisible(true);
    }

    public void actionPerformed(ActionEvent evt) {


        File definitions = cgi.getCurrentDefinitionFile();
        File configuration = cgi.getCurrentConfigurationFile();

        if (definitions == null) {
            definitions = new File("securityanalyzer/jsatDefinitions.xml");
        //definitions = new File(project.getAbsolutePath() + "/nbproject/jsat/" +
        //        "jsatDefinitions.xml");
        }

        if (!definitions.exists()) {
            definitions = new File("securityanalyzer/jsatDefinitions.xml");
        //definitions = new File(project.getAbsolutePath() + "/nbproject/jsat/" +
        //        "jsatDefinitions.xml");
        }



        SecurityModel sm = main.getSecurityModel();

        sm.setup(definitions.getAbsolutePath());

        if (cgi.getLaunchExistingPolicyRadioButton().isSelected()) {
            if (configuration == null || !configuration.exists()) {
                RulesActionsContainer rac = new RulesActionsContainer();

                String startingName = "policyConfiguration1";

                sm.getDefaultCodeGroup().addExternalPolicy(startingName, rac);
                main.setDefaultPolicyName(startingName);
                main.setCurrentPolicyName(startingName);
            } else {
                //TODO : make this more flexible by adding support for other import classes
                PolicyConfigurationReader pcr = new PolicyConfigurationReader(configuration);

                RulesActionsContainer rac = new RulesActionsContainer();

                pcr.importPolicy(rac);

                String startingName = configuration.getName();

                sm.getDefaultCodeGroup().addExternalPolicy(startingName, rac);
                main.setDefaultPolicyName(startingName);
                main.setCurrentPolicyName(startingName);
            }
        } else {
            RulesActionsContainer rac = new RulesActionsContainer();

            String startingName = cgi.getConfigurationNameTextField().getText();

            sm.getDefaultCodeGroup().addExternalPolicy(startingName, rac);

            main.setDefaultPolicyName(startingName);
            main.setCurrentPolicyName(startingName);
        }

        cgi.dispose();

        main.initCodeGroup();

        main.refreshFilterList();


    }
}
