package org.sun.jsat.controllers;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.swing.JFileChooser;
import org.netbeans.spi.project.ui.support.ProjectChooser;
import org.sun.jsat.JSATMain;
import securityanalyzer.analysismodel.PermissionDescription;
import securityanalyzer.analysismodel.PermissionRequirement;
import securityanalyzer.analysismodel.tools.soot.SootAnalysisTool;
import securityanalyzer.resourcemodel.FilledRuleDefinitionCollection;
import securityanalyzer.resourcemodel.PermissionConverter;
import securityanalyzer.useframework.RulesActionsContainer;

public class StaticAnalysisController implements ActionListener {

    private JSATMain main;

    public StaticAnalysisController(JSATMain main) {
        this.main = main;
    }

    public void actionPerformed(ActionEvent e) {
        JFileChooser projectChooser = ProjectChooser.projectChooser();
        int returnFromSelection = projectChooser.showOpenDialog(projectChooser.getParent());

        if (returnFromSelection == JFileChooser.APPROVE_OPTION) {
            File f = projectChooser.getSelectedFile();
            //TODO this is messy
            File binDir = new File(f.getAbsoluteFile() + "build/classes/");
            SootAnalysisTool sat = new SootAnalysisTool(binDir.getAbsolutePath(), null);
            sat.runAnalysis();
            List<PermissionRequirement> result = sat.getAllFindings();
            List<PermissionDescription> pDescs = new ArrayList<PermissionDescription>();
            for (PermissionRequirement pr : result){
                pDescs.add(pr.getPermission());
            }
            FilledRuleDefinitionCollection frdc = new PermissionConverter().convertToRules(pDescs);
            RulesActionsContainer rac = new RulesActionsContainer();
            rac.addRules(frdc);
            rac.updateActionsFromRules();
            main.getSecurityModel().getDefaultCodeGroup().addAnalysisPolicy("Soot-" + new Date().toString(), rac);
        }
    }
}
