package org.sun.jsat.trees;

import java.awt.event.MouseEvent;
import javax.swing.JTree;
import javax.swing.ToolTipManager;
import javax.swing.tree.TreePath;

/**
 *
 * 
 */
public class ToolTipTree extends JTree {

    public ToolTipTree(){
        super();
        init();
    }
    
    public ToolTipTree(RefreshableTreeNode rootTreeNode) {
        super(rootTreeNode);
        init();
    }
    
    private void init(){
        ToolTipManager.sharedInstance().registerComponent(this);
        super.setToolTipText("");
        this.setCellRenderer(new HighlightingTreeCellRenderer());
    }

    @Override
    public String getToolTipText(MouseEvent evt) {
        if (getRowForLocation(evt.getX(), evt.getY()) == -1) {
            return null;
        }
        TreePath curPath = getPathForLocation(evt.getX(), evt.getY());
        Object nd = curPath.getLastPathComponent();
        if (nd instanceof RefreshableTreeNode) {
            return ((RefreshableTreeNode) nd).toolTipText();
        } else {
            return "";
        }
    }
}
