package securityanalyzer.analysisexecution;

import java.util.HashSet;
import java.util.Set;

import securityanalyzer.analysismodel.AnalysisModel;

/**
 * 
 * Deals with execution of analysis tasks and manages the {@link AnalysisModel}
 *
 */
public class AnalysisEngine {

	private static Set<AnalysisTool> tools = new HashSet<AnalysisTool>(); 
	
	/**
	 * Run the analysis specified by the given tool.
	 * 
	 * @param tool
	 * @return
	 */
	public static void runAnalysis(AnalysisTool tool){
		tools.add(tool);
		tool.runAnalysis();
	}
}
