package securityanalyzer.analysismodel;

/**
 * 
 * A Visitor used to do advanced calculations on the permission requirements of
 * CodeBlocks
 * 
 */
public interface PolicyApplicationStrategy {

	/**
	 * Process a given CodeBlock's permissions (and possibly visit another
	 * related CodeBlock)
	 * 
	 * @param cb
	 *            starting CodeBlock
	 */
	public void process(CodeBlock cb);
	
	/**
	 * Get the policy that has resulted from this application strategy's analysis
	 * @return
	 */
	public ResultantPolicyDescription getResultantPolicy();
	
}
