package securityanalyzer.analysismodel.tools;

import securityanalyzer.analysisexecution.AnalysisTool;
import securityanalyzer.analysismodel.AnalysisModel;
import securityanalyzer.analysismodel.CodeBlock;
import securityanalyzer.analysismodel.Method;
import securityanalyzer.analysismodel.MethodInvocation;

public abstract class StaticAnalysisTool extends AnalysisTool {

	public void runAnalysis() {
		//TODO encapsulate static analysis algorithm here
	}

	public CodeBlock addClass(String name) {
		try {
			return AnalysisModel.addCodeBlock("Class", name);
		} catch (RuntimeException re) {
			return null;
		}
	}

	public Method addMethod(String name, String parent) {
		CodeBlock cb = AnalysisModel.findByName(parent);

		if (cb == null) {
			return null;
		}

		try {
			return AnalysisModel.createMethod(name, cb);
		} catch (ClassCastException e) {
			System.out.println(e.getMessage());
			return null;
		} catch (RuntimeException e) {
			System.out.println(e.getMessage());
			return null;
		}
	}

	public boolean hasMethod(String name) {
		return (AnalysisModel.findByName(name) != null);
	}

	public MethodInvocation addMethodInvocation(Method caller, Method callee,
			boolean priv, boolean thread) {
		// this creates the invocation and adds it the the appropriate lists in the methods
		return new MethodInvocation(caller, callee, priv, thread);
	}
}
