package securityanalyzer.resourcemodel;

import java.util.Map.Entry;

/**
 * 
 * Defines an instance of a Rule
 * 
 */
public class FilledRuleDefinition extends FilledParameterContainer<RuleDefinition> {

	/**
	 * Constructor
	 * 
	 * @param pd
	 *            The rule to create an instance of
	 */
	public FilledRuleDefinition(RuleDefinition pd) {
		super(pd);
	}
	
    @Override
	public int hashCode() {
		
		String s = base.getType() + base.getName();
		
		for(String value: parameterMappings.values()) {
			s += value;
		}
		
		return s.hashCode();
	}
	
    @Override
	public String toString() {
		
		String s = base.getType() + base.getName() + "(";
		
		for(Entry<ParameterDefinition, String> e: parameterMappings.entrySet()) {
			s += e.getKey() + "=[" + e.getValue() + "] ";
		}
		
		s += ")";
		
		return s;
		
	}
	
	
    @Override
	public boolean equals(Object o) {
		
		if(!(o instanceof FilledRuleDefinition)) {
			return false;
		}
		
		FilledRuleDefinition frd = (FilledRuleDefinition)o;
		
		if(frd.base != this.base) {
			return false;
		}
		
		for(Entry<ParameterDefinition, String> e: frd.getAllDefinedMappings().entrySet()) {
			if(!this.getMapping(e.getKey()).equals(e.getValue())) {
				return false;
			}
		}
		
		return true;
		
	}
}
