package securityanalyzer.useframework;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;


public class CodeGrouping {
	
	private RulesActionsContainer currentPolicy = new RulesActionsContainer();
	private Map<String, RulesActionsContainer> analysisPolicies = new HashMap<String, RulesActionsContainer>();
	private Map<String, RulesActionsContainer> externalPolicies = new HashMap<String, RulesActionsContainer>();
	
	private String name;
	
	public CodeGrouping(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}
        
        public void addAnalysisPolicy(String name, RulesActionsContainer rac) {
            analysisPolicies.put(name, rac);
        }
        
        public void addExternalPolicy(String name, RulesActionsContainer rac) {
            externalPolicies.put(name, rac);
        }
	
	public RulesActionsContainer getCurrentPolicy() {
		return currentPolicy;
	}
	
	public Collection<String> getAllAnalysisPolicyNames(){
		return analysisPolicies.keySet();
	}
	
	public Collection<RulesActionsContainer> getAllAnalysisPolicies() {
		return analysisPolicies.values();
	}
	
	public RulesActionsContainer getAnalysisPolicyByName(String name) {
		return analysisPolicies.get(name);
	}
	
	public Collection<String> getAllExternalPolicyNames(){
		return externalPolicies.keySet();
	}
	
	public Collection<RulesActionsContainer> getAllExternalPolicies() {
		return externalPolicies.values();
	}
	
	public RulesActionsContainer getExternalPolicyByName(String name) {
		return externalPolicies.get(name);
	}
}
