package securityanalyzer.useframework;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import securityanalyzer.analysismodel.PermissionDescription;
import securityanalyzer.resourcemodel.PermissionConverter;

public class PolicyConfigurationWriter implements PolicyExporter {

    private File policyfile;
    
    public PolicyConfigurationWriter(String fileName){
        this.policyfile = new File(fileName);
    }
    
    public PolicyConfigurationWriter(File file){
        this.policyfile = file;
    }
    
    public void exportPolicy(RulesActionsContainer rac) {
        BufferedWriter out = null;
        try {
            out = new BufferedWriter(new FileWriter(policyfile));
            for (PermissionDescription pd : new PermissionConverter().convertToPolicySpecificObjects(rac.getRules())) {
                String str = pd.getPermissionClass();
                for (String arg : pd.getPermissionArgs()){
                    str += " {" + arg + "}";
                }
                str += "\n";
                out.write(str);
            }
        } catch (IOException ex) {
            Logger.getLogger(PolicyConfigurationWriter.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                out.close();
            } catch (IOException ex) {
                Logger.getLogger(PolicyConfigurationWriter.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

}
