package securityanalyzer.useframework;

import java.util.HashSet;
import java.util.Set;

import securityanalyzer.analysismodel.tools.StaticAnalysisTool;
import securityanalyzer.resourcemodel.ResourceModel;

public class SecurityModel {
	
	public static final String DEFAULT_CODE_GROUP_NAME = "default";
	
	private Set<CodeGrouping> codeGroups;
	
	public void setup(String resourceModelDefinitionFile){
		ResourceModel.loadFromXML(resourceModelDefinitionFile);
		codeGroups = new HashSet<CodeGrouping>();
		codeGroups.add(new CodeGrouping(DEFAULT_CODE_GROUP_NAME));
	}
	
	public void runStaticAnalysis(StaticAnalysisTool tool){
		//TODO joe, how do I run static analysis?
	}
	
	public CodeGrouping getCodeGroupByName(String name){
		for (CodeGrouping g : codeGroups){
			if (g.getName().equals(name)) return g;
		}
		return null;
	}
	
	public CodeGrouping getDefaultCodeGroup(){
		return getCodeGroupByName(DEFAULT_CODE_GROUP_NAME);
	}

}
